mvebu: split base-files across subtargets
authorAdrian Schmutzler <freifunk@adrianschmutzler.de>
Sat, 18 Jan 2020 01:21:13 +0000 (02:21 +0100)
committerAdrian Schmutzler <freifunk@adrianschmutzler.de>
Tue, 21 Jan 2020 13:24:49 +0000 (14:24 +0100)
For the mvebu target in particular, there is a lot of files in
base-files that are only relevant for one subtarget. Improve
overview and reduce size per subtarget by moving/splitting
base-files depending on the subtarget they belong to.

While at it, consolidate 01_leds by using the model part of
the board name as variable.

Signed-off-by: Adrian Schmutzler <freifunk@adrianschmutzler.de>
Acked-by: Tomasz Maciej Nowak <tomek_n@o2.pl>
26 files changed:
target/linux/mvebu/base-files/etc/board.d/01_leds [deleted file]
target/linux/mvebu/base-files/etc/board.d/02_network [deleted file]
target/linux/mvebu/base-files/etc/init.d/bootcount [deleted file]
target/linux/mvebu/base-files/etc/uci-defaults/03_wireless [deleted file]
target/linux/mvebu/base-files/etc/uci-defaults/04_mambafan [deleted file]
target/linux/mvebu/base-files/lib/preinit/06_set_iface_mac [deleted file]
target/linux/mvebu/base-files/lib/preinit/81_linksys_syscfg [deleted file]
target/linux/mvebu/base-files/lib/preinit/82_uDPU [deleted file]
target/linux/mvebu/base-files/lib/upgrade/linksys.sh [deleted file]
target/linux/mvebu/base-files/lib/upgrade/platform.sh [deleted file]
target/linux/mvebu/base-files/lib/upgrade/uDPU.sh [deleted file]
target/linux/mvebu/cortexa53/base-files/etc/board.d/02_network [new file with mode: 0755]
target/linux/mvebu/cortexa53/base-files/lib/preinit/82_uDPU [new file with mode: 0644]
target/linux/mvebu/cortexa53/base-files/lib/upgrade/platform.sh [new file with mode: 0755]
target/linux/mvebu/cortexa53/base-files/lib/upgrade/uDPU.sh [new file with mode: 0644]
target/linux/mvebu/cortexa72/base-files/etc/board.d/02_network [new file with mode: 0755]
target/linux/mvebu/cortexa72/base-files/lib/upgrade/platform.sh [new file with mode: 0755]
target/linux/mvebu/cortexa9/base-files/etc/board.d/01_leds [new file with mode: 0755]
target/linux/mvebu/cortexa9/base-files/etc/board.d/02_network [new file with mode: 0755]
target/linux/mvebu/cortexa9/base-files/etc/init.d/bootcount [new file with mode: 0755]
target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/03_wireless [new file with mode: 0644]
target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/04_mambafan [new file with mode: 0644]
target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac [new file with mode: 0644]
target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg [new file with mode: 0644]
target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh [new file with mode: 0644]
target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh [new file with mode: 0755]

diff --git a/target/linux/mvebu/base-files/etc/board.d/01_leds b/target/linux/mvebu/base-files/etc/board.d/01_leds
deleted file mode 100755 (executable)
index 14313ee..0000000
+++ /dev/null
@@ -1,55 +0,0 @@
-#!/bin/sh
-#
-# Copyright (C) 2014-2016 OpenWrt.org
-# Copyright (C) 2016 LEDE-Project.org
-#
-
-. /lib/functions/uci-defaults.sh
-
-board_config_update
-
-board=$(board_name)
-
-case "$board" in
-linksys,caiman)
-       ucidef_set_led_netdev "wan" "WAN" "pca963x:caiman:white:wan" "eth1"
-       ucidef_set_led_usbport "usb1" "USB 1" "pca963x:caiman:white:usb2" "usb1-port1"
-       ucidef_set_led_usbport "usb2" "USB 2" "pca963x:caiman:white:usb3_1" "usb2-port1" "usb3-port1"
-       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:caiman:white:usb3_2" "usb3-port1"
-       ;;
-linksys,cobra)
-       ucidef_set_led_netdev "wan" "WAN" "pca963x:cobra:white:wan" "eth1"
-       ucidef_set_led_usbport "usb1" "USB 1" "pca963x:cobra:white:usb2" "usb1-port1"
-       ucidef_set_led_usbport "usb2" "USB 2" "pca963x:cobra:white:usb3_1" "usb2-port1" "usb3-port1"
-       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:cobra:white:usb3_2" "usb3-port1"
-       ;;
-linksys,mamba)
-       ucidef_set_led_netdev "wan" "WAN" "mamba:white:wan" "eth1"
-       ucidef_set_led_usbport "usb1" "USB 1" "mamba:white:usb2" "usb1-port1"
-       ucidef_set_led_usbport "usb2" "USB 2" "mamba:white:usb3_1" "usb2-port1" "usb3-port1"
-       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "mamba:white:usb3_2" "usb3-port2"
-       ;;
-linksys,rango)
-       ucidef_set_led_netdev "wan" "WAN" "pca963x:rango:white:wan" "eth1"
-       ucidef_set_led_usbport "usb1" "USB 1" "pca963x:rango:white:usb2" "usb1-port1"
-       ucidef_set_led_usbport "usb2" "USB 2" "pca963x:rango:white:usb3_1" "usb2-port1" "usb3-port1"
-       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:rango:white:usb3_2" "usb3-port1"
-       ;;
-linksys,shelby)
-       ucidef_set_led_netdev "wan" "WAN" "pca963x:shelby:white:wan" "eth1"
-       ucidef_set_led_usbport "usb1" "USB 1" "pca963x:shelby:white:usb2" "usb1-port1"
-       ucidef_set_led_usbport "usb2" "USB 2" "pca963x:shelby:white:usb3_1" "usb2-port1" "usb3-port1"
-       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:shelby:white:usb3_2" "usb3-port1"
-       ;;
-linksys,venom)
-       ucidef_set_led_netdev "wan" "WAN" "pca963x:venom:blue:wan" "eth1"
-       ucidef_set_led_usbport "usb1" "USB 1" "pca963x:venom:blue:usb2" "usb1-port1"
-       ucidef_set_led_usbport "usb2" "USB 2" "pca963x:venom:blue:usb3_1" "usb2-port1" "usb3-port1"
-       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:venom:blue:usb3_2" "usb3-port1"
-       ;;
-
-esac
-
-board_config_flush
-
-exit 0
diff --git a/target/linux/mvebu/base-files/etc/board.d/02_network b/target/linux/mvebu/base-files/etc/board.d/02_network
deleted file mode 100755 (executable)
index 283a856..0000000
+++ /dev/null
@@ -1,78 +0,0 @@
-#!/bin/sh
-#
-# Copyright (C) 2014-2016 OpenWrt.org
-# Copyright (C) 2016 LEDE-Project.org
-#
-
-. /lib/functions/uci-defaults.sh
-
-board_config_update
-
-board=$(board_name)
-
-case "$board" in
-cznic,turris-omnia)
-       ucidef_set_interface_lan "lan0 lan1 lan2 lan3 lan4"
-       ucidef_set_interface_wan "eth2"
-       ;;
-globalscale,espressobin|\
-globalscale,espressobin-emmc|\
-globalscale,espressobin-v7|\
-globalscale,espressobin-v7-emmc)
-       ucidef_set_interfaces_lan_wan "lan0 lan1" "wan"
-       ;;
-linksys,caiman|\
-linksys,cobra|\
-linksys,mamba|\
-linksys,rango|\
-linksys,shelby|\
-linksys,venom)
-       ucidef_set_interfaces_lan_wan "eth0.1" "eth1.2"
-       ucidef_add_switch "switch0" \
-               "0:lan:4" "1:lan:3" "2:lan:2" "3:lan:1" "5@eth0" "4:wan" "6@eth1"
-       ;;
-marvell,a385-db-ap)
-       ucidef_set_interfaces_lan_wan "eth0 eth1" "eth2"
-       ;;
-marvell,armada8040-mcbin)
-       ucidef_set_interfaces_lan_wan "eth0 eth1 eth3" "eth2"
-       ;;
-marvell,armada8040-db)
-       ucidef_set_interfaces_lan_wan "eth0 eth2 eth3" "eth1"
-       ;;
-marvell,armada7040-db)
-       ucidef_set_interfaces_lan_wan "eth0 eth2" "eth1"
-       ;;
-marvell,armada-3720-db)
-       ucidef_set_interfaces_lan_wan "eth1" "eth0"
-       ;;
-marvell,axp-gp)
-       ucidef_set_interface_lan "eth0 eth1 eth2 eth3"
-       ;;
-methode,udpu)
-       ucidef_set_interfaces_lan_wan "eth1" "eth0"
-       ;;
-solidrun,clearfog-a1|solidrun,clearfog-pro-a1)
-       # eth0 is standalone ethernet
-       # eth1 is switch
-       # eth2 is SFP
-       ucidef_set_interfaces_lan_wan "eth1" "eth0 eth2"
-
-       # switch port 5 is connected to eth1
-       ucidef_add_switch "switch0" \
-               "0:lan:5" "1:lan:4" "2:lan:3" "3:lan:2" "4:lan:1" "5u@eth1" "6:lan:6"
-       ;;
-solidrun,clearfog-base-a1)
-       # eth0 is standalone ethernet
-       # eth1 is standalone ethernet
-       # eth2 is SFP
-       ucidef_set_interfaces_lan_wan "eth1" "eth0 eth2"
-       ;;
-*)
-       ucidef_set_interface_lan "eth0"
-       ;;
-esac
-
-board_config_flush
-
-exit 0
diff --git a/target/linux/mvebu/base-files/etc/init.d/bootcount b/target/linux/mvebu/base-files/etc/init.d/bootcount
deleted file mode 100755 (executable)
index dd2266b..0000000
+++ /dev/null
@@ -1,16 +0,0 @@
-#!/bin/sh /etc/rc.common
-
-START=99
-
-boot() {
-       case $(board_name) in
-       linksys,caiman |\
-       linksys,cobra |\
-       linksys,mamba |\
-       linksys,rango |\
-       linksys,shelby |\
-       linksys,venom)
-               mtd resetbc s_env || true
-               ;;
-       esac
-}
diff --git a/target/linux/mvebu/base-files/etc/uci-defaults/03_wireless b/target/linux/mvebu/base-files/etc/uci-defaults/03_wireless
deleted file mode 100644 (file)
index 3c345ff..0000000
+++ /dev/null
@@ -1,56 +0,0 @@
-#!/bin/sh
-#
-# Copyright (C) 2015 OpenWrt.org
-#
-
-[ ! -e /etc/config/wireless ] && exit 0
-
-. /lib/functions.sh
-. /lib/functions/system.sh
-
-board=$(board_name)
-
-case "$board" in
-linksys,caiman|linksys,cobra|linksys,mamba|linksys,shelby|linksys,venom)
-       SKU=$(strings /dev/mtd3|sed -ne 's/^cert_region=//p')
-       WIFIMAC2G=$(macaddr_add $(cat /sys/class/net/eth0/address) +1)
-       WIFIMAC5G=$(macaddr_add $WIFIMAC2G +1)
-       case "$SKU" in
-               AP)
-                       REGD=CN
-               ;;
-               AU)
-                       REGD=AU
-               ;;
-               CA)
-                       REGD=CA
-               ;;
-               EU)
-                       REGD=DE
-               ;;
-               US)
-                       REGD=US
-               ;;
-       esac
-
-       case "$board" in
-               linksys,mamba)
-                       WIFIMAC0=$WIFIMAC2G
-                       WIFIMAC1=$WIFIMAC5G
-               ;;
-               *)
-                       WIFIMAC0=$WIFIMAC5G
-                       WIFIMAC1=$WIFIMAC2G
-               ;;
-       esac
-
-       uci get wireless.radio0.country || uci set wireless.radio0.country=$REGD
-       uci get wireless.@wifi-iface[0].macaddr || uci set wireless.@wifi-iface[0].macaddr=$WIFIMAC0
-       uci get wireless.radio1.country || uci set wireless.radio1.country=$REGD
-       uci get wireless.@wifi-iface[1].macaddr || uci set wireless.@wifi-iface[1].macaddr=$WIFIMAC1
-       ;;
-esac
-
-uci commit wireless
-
-exit 0
diff --git a/target/linux/mvebu/base-files/etc/uci-defaults/04_mambafan b/target/linux/mvebu/base-files/etc/uci-defaults/04_mambafan
deleted file mode 100644 (file)
index ec25aed..0000000
+++ /dev/null
@@ -1,23 +0,0 @@
-#!/bin/sh
-#
-# Copyright (C) 2017 LEDE-Project.org
-#
-
-. /lib/functions.sh
-
-board=$(board_name)
-
-case "$board" in
-linksys,mamba)
-       # Set fan script execution in crontab
-       grep -s -q fan_ctrl.sh /etc/crontabs/root && exit 0
-
-       echo "# mamba fan script runs every 5 minutes" >> /etc/crontabs/root
-       echo "*/5 * * * * /sbin/fan_ctrl.sh" >> /etc/crontabs/root
-
-       # Execute one time after initial flash (instead of waiting 5 min for cron)
-       /sbin/fan_ctrl.sh
-       ;;
-esac
-
-exit 0
diff --git a/target/linux/mvebu/base-files/lib/preinit/06_set_iface_mac b/target/linux/mvebu/base-files/lib/preinit/06_set_iface_mac
deleted file mode 100644 (file)
index fd41836..0000000
+++ /dev/null
@@ -1,46 +0,0 @@
-#
-# Copyright (C) 2014-2015 OpenWrt.org
-# Copyright (C) 2016 LEDE-Project.org
-#
-
-preinit_set_mac_address() {
-       local mac
-
-       . /lib/functions.sh
-
-       case $(board_name) in
-       linksys,caiman|linksys,cobra|linksys,rango|linksys,shelby|linksys,venom)
-               # rename interfaces back to the way they were with 4.4
-               case "$(readlink /sys/class/net/eth0)" in
-                       *f1070000*)
-                               ip link set eth0 name tmp0
-                               ip link set eth1 name eth0
-                               ip link set tmp0 name eth1
-                       ;;
-               esac
-
-               mac=$(mtd_get_mac_ascii devinfo hw_mac_addr)
-               mac_wan=$(macaddr_setbit_la "$mac")
-               ip link set dev eth0 address $mac 2>/dev/null
-               ip link set dev eth1 address $mac_wan 2>/dev/null
-               ;;
-       linksys,mamba)
-               mac=$(mtd_get_mac_ascii devinfo hw_mac_addr)
-               ip link set dev eth0 address $mac 2>/dev/null
-               ip link set dev eth1 address $mac 2>/dev/null
-               ;;
-       marvell,a385-db-ap|solidrun,clearfog*a1)
-               # rename interfaces back to the way they were with 4.4
-               case "$(readlink /sys/class/net/eth0)" in
-                       *f1070000*)
-                               ip link set eth0 name tmp0
-                               ip link set eth1 name eth0
-                               ip link set eth2 name eth1
-                               ip link set tmp0 name eth2
-                       ;;
-               esac
-               ;;
-       esac
-}
-
-boot_hook_add preinit_main preinit_set_mac_address
diff --git a/target/linux/mvebu/base-files/lib/preinit/81_linksys_syscfg b/target/linux/mvebu/base-files/lib/preinit/81_linksys_syscfg
deleted file mode 100644 (file)
index 83448e5..0000000
+++ /dev/null
@@ -1,37 +0,0 @@
-#
-# Copyright (C) 2014-2016 OpenWrt.org
-# Copyright (C) 2016 LEDE-Project.org
-#
-
-preinit_mount_syscfg() {
-       . /lib/functions.sh
-       . /lib/upgrade/common.sh
-
-       case $(board_name) in
-       linksys,caiman|linksys,cobra|linksys,mamba|linksys,rango|linksys,shelby|linksys,venom)
-               needs_recovery=0
-               syscfg_part=$(grep syscfg /proc/mtd |cut -c4)
-               ubiattach -m $syscfg_part || needs_recovery=1
-               if [ $needs_recovery -eq 1 ]
-               then
-                       echo "ubifs syscfg partition is damaged, reformatting"
-                       ubidetach -m $syscfg_part
-                       ubiformat -y -O 2048 -q /dev/mtd$syscfg_part
-                       ubiattach -m $syscfg_part
-                       ubimkvol /dev/ubi1 -n 0 -N syscfg -t dynamic --maxavsize
-               fi
-               mkdir /tmp/syscfg
-               mount -t ubifs ubi1:syscfg /tmp/syscfg
-               [ -f "/tmp/syscfg/$BACKUP_FILE" ] && {
-               echo "- config restore -"
-               cd /
-               mv "/tmp/syscfg/$BACKUP_FILE" /tmp
-               tar xzf "/tmp/$BACKUP_FILE"
-               rm -f "/tmp/$BACKUP_FILE"
-               sync
-               }
-               ;;
-       esac
-}
-
-boot_hook_add preinit_main preinit_mount_syscfg
diff --git a/target/linux/mvebu/base-files/lib/preinit/82_uDPU b/target/linux/mvebu/base-files/lib/preinit/82_uDPU
deleted file mode 100644 (file)
index 12bbfc3..0000000
+++ /dev/null
@@ -1,48 +0,0 @@
-#
-# Copyright (C) 2014-2019 OpenWrt.org
-# Copyright (C) 2016 LEDE-Project.org
-#
-
-preinit_mount_udpu() {
-       . /lib/functions.sh
-       . /lib/upgrade/common.sh
-
-       case $(board_name) in
-       methode,udpu)
-               # Check which device is detected
-               [ -b "/dev/mmcblk0" ] && mmcdev="/dev/mmcblk0" || mmcdev="/dev/mmcblk1"
-
-               if [ -b "${mmcdev}p4" ]; then
-                       mkdir /misc
-                       mount -t f2fs ${mmcdev}p4 /misc
-                       [ -f "/misc/$BACKUP_FILE" ] && {
-                               echo "- Restoring configuration files -"
-                               tar xzf "/misc/$BACKUP_FILE" -C /
-                               rm -f "/misc/$BACKUP_FILE"
-                               sync
-                       }
-                       [ -f "/misc/firmware/recovery.itb" ] && {
-                                       echo "- Updating /recovery partition -"
-                                       mkfs.ext4 -q ${mmcdev}p2 | echo y &> /dev/null
-                                       mkdir -p /tmp/recovery
-                                       mount ${mmcdev}p2 /tmp/recovery
-                                       cp /misc/firmware/recovery.itb /tmp/recovery
-                                       [ -f "/misc/firmware/boot.scr" ] && \
-                                               cp /misc/firmware/boot.scr /tmp/recovery
-                                       sync
-                                       umount /tmp/recovery
-                                       rm -rf /tmp/recovery
-
-                                       # Replace previous backup with the new one
-                                       [ -d "/misc/firmware_old" ] && rm -rf /misc/firmware_old
-                                       [ -d "/misc/firmware" ] && mv /misc/firmware /misc/firmware_old
-                               }
-               fi
-
-               # Legacy support - if rootfs was booted, instruct u-boot to keep the current root dev
-               [ "$(df | grep /dev/root)" ] && fw_setenv root_ok '2'
-       ;;
-       esac
-}
-
-boot_hook_add preinit_main preinit_mount_udpu
diff --git a/target/linux/mvebu/base-files/lib/upgrade/linksys.sh b/target/linux/mvebu/base-files/lib/upgrade/linksys.sh
deleted file mode 100644 (file)
index 6ccfdd0..0000000
+++ /dev/null
@@ -1,98 +0,0 @@
-#
-# Copyright (C) 2014-2015 OpenWrt.org
-#
-
-linksys_get_target_firmware() {
-
-       local cur_boot_part mtd_ubi0
-
-       cur_boot_part=$(/usr/sbin/fw_printenv -n boot_part)
-       if [ -z "${cur_boot_part}" ] ; then
-               mtd_ubi0=$(cat /sys/devices/virtual/ubi/ubi0/mtd_num)
-               case $(egrep ^mtd${mtd_ubi0}: /proc/mtd | cut -d '"' -f 2) in
-               kernel1|rootfs1)
-                       cur_boot_part=1
-                       ;;
-               kernel2|rootfs2)
-                       cur_boot_part=2
-                       ;;
-               esac
-               >&2 printf "Current boot_part='%s' selected from ubi0/mtd_num='%s'" \
-                       "${cur_boot_part}" "${mtd_ubi0}"
-       fi
-
-       case $cur_boot_part in
-       1)
-               fw_setenv -s - <<-EOF
-                       boot_part 2
-                       bootcmd "run altnandboot"
-               EOF
-               printf "kernel2"
-               return
-               ;;
-       2)
-               fw_setenv -s - <<-EOF
-                       boot_part 1
-                       bootcmd "run nandboot"
-               EOF
-               printf "kernel1"
-               return
-               ;;
-       *)
-               return
-               ;;
-       esac
-}
-
-linksys_get_root_magic() {
-       (get_image "$@" | dd skip=786432 bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
-}
-
-platform_do_upgrade_linksys() {
-       local magic_long="$(get_magic_long "$1")"
-
-       mkdir -p /var/lock
-       local part_label="$(linksys_get_target_firmware)"
-       touch /var/lock/fw_printenv.lock
-
-       if [ ! -n "$part_label" ]
-       then
-               echo "cannot find target partition"
-               exit 1
-       fi
-
-       local target_mtd=$(find_mtd_part $part_label)
-
-       [ "$magic_long" = "73797375" ] && {
-               CI_KERNPART="$part_label"
-               if [ "$part_label" = "kernel1" ]
-               then
-                       CI_UBIPART="rootfs1"
-               else
-                       CI_UBIPART="rootfs2"
-               fi
-
-               nand_upgrade_tar "$1"
-       }
-       [ "$magic_long" = "27051956" -o "$magic_long" = "0000a0e1" ] && {
-               # check firmwares' rootfs types
-               local target_mtd=$(find_mtd_part $part_label)
-               local oldroot="$(linksys_get_root_magic $target_mtd)"
-               local newroot="$(linksys_get_root_magic "$1")"
-
-               if [ "$newroot" = "55424923" -a "$oldroot" = "55424923" ]
-               # we're upgrading from a firmware with UBI to one with UBI
-               then
-                       # erase everything to be safe
-                       mtd erase $part_label
-                       get_image "$1" | mtd -n write - $part_label
-               else
-                       get_image "$1" | mtd write - $part_label
-               fi
-       }
-}
-
-platform_copy_config_linksys() {
-       cp -f "$UPGRADE_BACKUP" "/tmp/syscfg/$BACKUP_FILE"
-       sync
-}
diff --git a/target/linux/mvebu/base-files/lib/upgrade/platform.sh b/target/linux/mvebu/base-files/lib/upgrade/platform.sh
deleted file mode 100755 (executable)
index 0223b72..0000000
+++ /dev/null
@@ -1,52 +0,0 @@
-#
-# Copyright (C) 2014-2016 OpenWrt.org
-# Copyright (C) 2016 LEDE-Project.org
-#
-
-RAMFS_COPY_BIN='fw_printenv fw_setenv'
-RAMFS_COPY_DATA='/etc/fw_env.config /var/lock/fw_printenv.lock'
-REQUIRE_IMAGE_METADATA=1
-
-platform_check_image() {
-       case "$(board_name)" in
-       cznic,turris-omnia|globalscale,espressobin|globalscale,espressobin-emmc|globalscale,espressobin-v7|globalscale,espressobin-v7-emmc|\
-       marvell,armada8040-mcbin|solidrun,clearfog-base-a1|solidrun,clearfog-pro-a1)
-               platform_check_image_sdcard "$1"
-               ;;
-       *)
-               return 0
-               ;;
-       esac
-}
-
-platform_do_upgrade() {
-       case "$(board_name)" in
-       linksys,caiman|linksys,cobra|linksys,mamba|linksys,rango|linksys,shelby|linksys,venom)
-               platform_do_upgrade_linksys "$1"
-               ;;
-       cznic,turris-omnia|globalscale,espressobin|globalscale,espressobin-emmc|globalscale,espressobin-v7|globalscale,espressobin-v7-emmc|\
-       marvell,armada8040-mcbin|solidrun,clearfog-base-a1|solidrun,clearfog-pro-a1)
-               platform_do_upgrade_sdcard "$1"
-               ;;
-       methode,udpu)
-               platform_do_upgrade_uDPU "$1"
-               ;;
-       *)
-               default_do_upgrade "$1"
-               ;;
-       esac
-}
-platform_copy_config() {
-       case "$(board_name)" in
-       linksys,caiman|linksys,cobra|linksys,mamba|linksys,rango|linksys,shelby|linksys,venom)
-               platform_copy_config_linksys
-               ;;
-       cznic,turris-omnia|globalscale,espressobin|globalscale,espressobin-emmc|globalscale,espressobin-v7|globalscale,espressobin-v7-emmc|\
-       marvell,armada8040-mcbin|solidrun,clearfog-base-a1|solidrun,clearfog-pro-a1)
-               platform_copy_config_sdcard
-               ;;
-       methode,udpu)
-               platform_copy_config_uDPU
-               ;;
-       esac
-}
diff --git a/target/linux/mvebu/base-files/lib/upgrade/uDPU.sh b/target/linux/mvebu/base-files/lib/upgrade/uDPU.sh
deleted file mode 100644 (file)
index 032c706..0000000
+++ /dev/null
@@ -1,156 +0,0 @@
-udpu_check_emmc() {
-# uDPU uses combined ext4 and f2fs partitions.
-# partition layout:
-#      1. boot (ext4)
-#      2. recovery  (ext4)
-#      3. rootfs (f2fs)
-#      4. misc (f2fs)
-
-       # Check which device is available, depending on the board revision
-       if [ -b "/dev/mmcblk1" ]; then
-               emmc_dev=/dev/mmcblk1
-       elif [ -b "/dev/mmcblk0" ]; then
-               emmc_dev=/dev/mmcblk0
-       else
-               echo "Cannot detect eMMC flash, aborting.."
-               exit 1
-       fi
-}
-
-udpu_part_prep() {
-        if [ "$(grep $1 /proc/mounts)" ]; then
-               mounted_part="$(grep $1 /proc/mounts | awk '{print $2}' | head -1)"
-               umount $mounted_part
-               [ "$(grep -wo $mounted_part /proc/mounts)" ] && umount -l $mounted_part
-       fi
-}
-
-udpu_do_part_check() {
-       local emmc_parts="1 2 3 4"
-       local part_valid="1"
-
-       # Check if the block devices exist
-       for num in ${emmc_parts}; do
-               [[ ! -b ${emmc_dev}p${num} ]] && part_valid="0"
-       done
-
-       # If partitions are missing create a new partition table
-       if [ "$part_valid" != "1" ]; then
-               printf "Invalid partition table, creating a new one\n"
-               printf "o\nn\np\n1\n\n+256M\nn\np\n2\n\n+256M\nn\np\n3\n\n+1536M\nn\np\n\n\nw\n" | fdisk -W always $emmc_dev  > /dev/null 2>&1
-
-               # Format the /misc part right away as we will need it for the firmware
-               printf "Formating /misc partition, this make take a while..\n"
-               udpu_part_prep ${emmc_dev}p4
-               mkfs.f2fs -q -l misc ${emmc_dev}p4
-               [ $? -eq 0 ] && printf "/misc partition formated successfully\n" || printf "/misc partition formatting failed\n"
-
-               udpu_do_initial_setup
-       else
-               printf "Partition table looks ok\n"
-       fi
-}
-
-udpu_do_misc_prep() {
-       if [ ! "$(grep -wo /misc /proc/mounts)" ]; then
-               mkdir -p /misc
-               mount ${emmc_dev}p4 /misc
-
-               # If the mount fails, try to reformat partition
-               # Leaving possiblity for multiple iterations
-               if [ $? -ne 0 ]; then
-                       printf "Error while mounting /misc, trying to reformat..\n"
-
-                       format_count=0
-                       while [ "$format_count" -lt "1" ]; do
-                               udpu_part_prep ${emmc_dev}p4
-                               mkfs.f2fs -q -l misc ${emmc_dev}p4
-                               mount ${emmc_dev}p4 /misc
-                               if [ $? -ne 0 ]; then
-                                       umount -l /misc
-                                       printf "Failed while mounting /misc\n"
-                                       format_count=$((format_count +1))
-                               else
-                                       printf "Mounted /misc successfully\n"
-                                       break
-                               fi
-                       done
-               fi
-       fi
-}
-
-udpu_do_initial_setup() {
-       # Prepare /recovery parition
-       udpu_part_prep ${emmc_dev}p2
-       mkfs.ext4 -q ${emmc_dev}p2 | echo y &> /dev/null
-
-       # Prepare /boot partition
-       udpu_part_prep ${emmc_dev}p1
-       mkfs.ext4 -q ${emmc_dev}p1 | echo y &> /dev/null
-
-       # Prepare /root partition
-       printf "Formating /root partition, this may take a while..\n"
-       udpu_part_prep ${emmc_dev}p3
-       mkfs.f2fs -q -l rootfs ${emmc_dev}p3
-       [ $? -eq 0 ] && printf "/root partition reformated\n"
-}
-
-udpu_do_regular_upgrade() {
-       # Clean /boot partition - mfks.ext4 is not available in chroot
-       [ "$(grep -wo /boot /proc/mounts)" ] && umount /boot
-       mkdir -p /tmp/boot
-       mount ${emmc_dev}p1 /tmp/boot
-       rm -rf /tmp/boot/*
-
-       # Clean /root partition - mkfs.f2fs is not available in chroot
-       [ "$(grep -wo /dev/root /proc/mounts)" ] && umount /
-       mkdir -p /tmp/rootpart
-       mount ${emmc_dev}p3 /tmp/rootpart
-       rm -rf /tmp/rootpart/*
-}
-
-platform_do_upgrade_uDPU() {
-       udpu_check_emmc
-
-       # Prepare and extract firmware on /misc partition
-       udpu_do_misc_prep
-
-       [ -f "/misc/firmware" ] && rm -r /misc/firmware
-       mkdir -p /misc/firmware
-       tar xzf "$1" -C /misc/firmware/
-
-       udpu_do_regular_upgrade
-
-       printf "Updating /boot partition\n"
-       tar xzf /misc/firmware/boot.tgz -C /tmp/boot
-       [ $? -eq 0 ] && printf "/boot partition updated successfully\n" || printf "/boot partition update failed\n"
-       sync
-
-       printf "Updating /root partition\n"
-       tar xzf /misc/firmware/rootfs.tgz -C /tmp/rootpart
-       [ $? -eq 0 ] && printf "/root partition updated successfully\n" || printf "/root partition update failed\n"
-       sync
-
-       # Saving configuration files over sysupgrade
-       platform_copy_config_uDPU
-
-       # Remove tmp mounts
-       tmp_parts=$(grep "${emmc_dev}" /proc/mounts | awk '{print $2}')
-       for part in ${tmp_parts}; do
-               umount $part
-               # Force umount is necessary
-               [ "$(grep "${part}" /proc/mounts)" ] && umount -l $part
-       done
-
-       # Sysupgrade complains about /tmp and /dev, so we can detach them here
-       umount -l /tmp
-       umount -l /dev
-}
-
-platform_copy_config_uDPU() {
-       # Config is saved on the /misc partition and copied on the rootfs after the reboot
-       if [ -f "$UPGRADE_BACKUP" ]; then
-               cp -f "$UPGRADE_BACKUP" "/misc/$BACKUP_FILE"
-               sync
-       fi
-}
diff --git a/target/linux/mvebu/cortexa53/base-files/etc/board.d/02_network b/target/linux/mvebu/cortexa53/base-files/etc/board.d/02_network
new file mode 100755 (executable)
index 0000000..ba4b930
--- /dev/null
@@ -0,0 +1,31 @@
+#!/bin/sh
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+. /lib/functions/uci-defaults.sh
+
+board_config_update
+
+board=$(board_name)
+
+case "$board" in
+globalscale,espressobin|\
+globalscale,espressobin-emmc|\
+globalscale,espressobin-v7|\
+globalscale,espressobin-v7-emmc)
+       ucidef_set_interfaces_lan_wan "lan0 lan1" "wan"
+       ;;
+marvell,armada-3720-db|\
+methode,udpu)
+       ucidef_set_interfaces_lan_wan "eth1" "eth0"
+       ;;
+*)
+       ucidef_set_interface_lan "eth0"
+       ;;
+esac
+
+board_config_flush
+
+exit 0
diff --git a/target/linux/mvebu/cortexa53/base-files/lib/preinit/82_uDPU b/target/linux/mvebu/cortexa53/base-files/lib/preinit/82_uDPU
new file mode 100644 (file)
index 0000000..12bbfc3
--- /dev/null
@@ -0,0 +1,48 @@
+#
+# Copyright (C) 2014-2019 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+preinit_mount_udpu() {
+       . /lib/functions.sh
+       . /lib/upgrade/common.sh
+
+       case $(board_name) in
+       methode,udpu)
+               # Check which device is detected
+               [ -b "/dev/mmcblk0" ] && mmcdev="/dev/mmcblk0" || mmcdev="/dev/mmcblk1"
+
+               if [ -b "${mmcdev}p4" ]; then
+                       mkdir /misc
+                       mount -t f2fs ${mmcdev}p4 /misc
+                       [ -f "/misc/$BACKUP_FILE" ] && {
+                               echo "- Restoring configuration files -"
+                               tar xzf "/misc/$BACKUP_FILE" -C /
+                               rm -f "/misc/$BACKUP_FILE"
+                               sync
+                       }
+                       [ -f "/misc/firmware/recovery.itb" ] && {
+                                       echo "- Updating /recovery partition -"
+                                       mkfs.ext4 -q ${mmcdev}p2 | echo y &> /dev/null
+                                       mkdir -p /tmp/recovery
+                                       mount ${mmcdev}p2 /tmp/recovery
+                                       cp /misc/firmware/recovery.itb /tmp/recovery
+                                       [ -f "/misc/firmware/boot.scr" ] && \
+                                               cp /misc/firmware/boot.scr /tmp/recovery
+                                       sync
+                                       umount /tmp/recovery
+                                       rm -rf /tmp/recovery
+
+                                       # Replace previous backup with the new one
+                                       [ -d "/misc/firmware_old" ] && rm -rf /misc/firmware_old
+                                       [ -d "/misc/firmware" ] && mv /misc/firmware /misc/firmware_old
+                               }
+               fi
+
+               # Legacy support - if rootfs was booted, instruct u-boot to keep the current root dev
+               [ "$(df | grep /dev/root)" ] && fw_setenv root_ok '2'
+       ;;
+       esac
+}
+
+boot_hook_add preinit_main preinit_mount_udpu
diff --git a/target/linux/mvebu/cortexa53/base-files/lib/upgrade/platform.sh b/target/linux/mvebu/cortexa53/base-files/lib/upgrade/platform.sh
new file mode 100755 (executable)
index 0000000..cdf5933
--- /dev/null
@@ -0,0 +1,52 @@
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+RAMFS_COPY_BIN='fw_printenv fw_setenv'
+RAMFS_COPY_DATA='/etc/fw_env.config /var/lock/fw_printenv.lock'
+REQUIRE_IMAGE_METADATA=1
+
+platform_check_image() {
+       case "$(board_name)" in
+       globalscale,espressobin|\
+       globalscale,espressobin-emmc|\
+       globalscale,espressobin-v7|\
+       globalscale,espressobin-v7-emmc)
+               platform_check_image_sdcard "$1"
+               ;;
+       *)
+               return 0
+               ;;
+       esac
+}
+
+platform_do_upgrade() {
+       case "$(board_name)" in
+       globalscale,espressobin|\
+       globalscale,espressobin-emmc|\
+       globalscale,espressobin-v7|\
+       globalscale,espressobin-v7-emmc)
+               platform_do_upgrade_sdcard "$1"
+               ;;
+       methode,udpu)
+               platform_do_upgrade_uDPU "$1"
+               ;;
+       *)
+               default_do_upgrade "$1"
+               ;;
+       esac
+}
+platform_copy_config() {
+       case "$(board_name)" in
+       globalscale,espressobin|\
+       globalscale,espressobin-emmc|\
+       globalscale,espressobin-v7|\
+       globalscale,espressobin-v7-emmc)
+               platform_copy_config_sdcard
+               ;;
+       methode,udpu)
+               platform_copy_config_uDPU
+               ;;
+       esac
+}
diff --git a/target/linux/mvebu/cortexa53/base-files/lib/upgrade/uDPU.sh b/target/linux/mvebu/cortexa53/base-files/lib/upgrade/uDPU.sh
new file mode 100644 (file)
index 0000000..032c706
--- /dev/null
@@ -0,0 +1,156 @@
+udpu_check_emmc() {
+# uDPU uses combined ext4 and f2fs partitions.
+# partition layout:
+#      1. boot (ext4)
+#      2. recovery  (ext4)
+#      3. rootfs (f2fs)
+#      4. misc (f2fs)
+
+       # Check which device is available, depending on the board revision
+       if [ -b "/dev/mmcblk1" ]; then
+               emmc_dev=/dev/mmcblk1
+       elif [ -b "/dev/mmcblk0" ]; then
+               emmc_dev=/dev/mmcblk0
+       else
+               echo "Cannot detect eMMC flash, aborting.."
+               exit 1
+       fi
+}
+
+udpu_part_prep() {
+        if [ "$(grep $1 /proc/mounts)" ]; then
+               mounted_part="$(grep $1 /proc/mounts | awk '{print $2}' | head -1)"
+               umount $mounted_part
+               [ "$(grep -wo $mounted_part /proc/mounts)" ] && umount -l $mounted_part
+       fi
+}
+
+udpu_do_part_check() {
+       local emmc_parts="1 2 3 4"
+       local part_valid="1"
+
+       # Check if the block devices exist
+       for num in ${emmc_parts}; do
+               [[ ! -b ${emmc_dev}p${num} ]] && part_valid="0"
+       done
+
+       # If partitions are missing create a new partition table
+       if [ "$part_valid" != "1" ]; then
+               printf "Invalid partition table, creating a new one\n"
+               printf "o\nn\np\n1\n\n+256M\nn\np\n2\n\n+256M\nn\np\n3\n\n+1536M\nn\np\n\n\nw\n" | fdisk -W always $emmc_dev  > /dev/null 2>&1
+
+               # Format the /misc part right away as we will need it for the firmware
+               printf "Formating /misc partition, this make take a while..\n"
+               udpu_part_prep ${emmc_dev}p4
+               mkfs.f2fs -q -l misc ${emmc_dev}p4
+               [ $? -eq 0 ] && printf "/misc partition formated successfully\n" || printf "/misc partition formatting failed\n"
+
+               udpu_do_initial_setup
+       else
+               printf "Partition table looks ok\n"
+       fi
+}
+
+udpu_do_misc_prep() {
+       if [ ! "$(grep -wo /misc /proc/mounts)" ]; then
+               mkdir -p /misc
+               mount ${emmc_dev}p4 /misc
+
+               # If the mount fails, try to reformat partition
+               # Leaving possiblity for multiple iterations
+               if [ $? -ne 0 ]; then
+                       printf "Error while mounting /misc, trying to reformat..\n"
+
+                       format_count=0
+                       while [ "$format_count" -lt "1" ]; do
+                               udpu_part_prep ${emmc_dev}p4
+                               mkfs.f2fs -q -l misc ${emmc_dev}p4
+                               mount ${emmc_dev}p4 /misc
+                               if [ $? -ne 0 ]; then
+                                       umount -l /misc
+                                       printf "Failed while mounting /misc\n"
+                                       format_count=$((format_count +1))
+                               else
+                                       printf "Mounted /misc successfully\n"
+                                       break
+                               fi
+                       done
+               fi
+       fi
+}
+
+udpu_do_initial_setup() {
+       # Prepare /recovery parition
+       udpu_part_prep ${emmc_dev}p2
+       mkfs.ext4 -q ${emmc_dev}p2 | echo y &> /dev/null
+
+       # Prepare /boot partition
+       udpu_part_prep ${emmc_dev}p1
+       mkfs.ext4 -q ${emmc_dev}p1 | echo y &> /dev/null
+
+       # Prepare /root partition
+       printf "Formating /root partition, this may take a while..\n"
+       udpu_part_prep ${emmc_dev}p3
+       mkfs.f2fs -q -l rootfs ${emmc_dev}p3
+       [ $? -eq 0 ] && printf "/root partition reformated\n"
+}
+
+udpu_do_regular_upgrade() {
+       # Clean /boot partition - mfks.ext4 is not available in chroot
+       [ "$(grep -wo /boot /proc/mounts)" ] && umount /boot
+       mkdir -p /tmp/boot
+       mount ${emmc_dev}p1 /tmp/boot
+       rm -rf /tmp/boot/*
+
+       # Clean /root partition - mkfs.f2fs is not available in chroot
+       [ "$(grep -wo /dev/root /proc/mounts)" ] && umount /
+       mkdir -p /tmp/rootpart
+       mount ${emmc_dev}p3 /tmp/rootpart
+       rm -rf /tmp/rootpart/*
+}
+
+platform_do_upgrade_uDPU() {
+       udpu_check_emmc
+
+       # Prepare and extract firmware on /misc partition
+       udpu_do_misc_prep
+
+       [ -f "/misc/firmware" ] && rm -r /misc/firmware
+       mkdir -p /misc/firmware
+       tar xzf "$1" -C /misc/firmware/
+
+       udpu_do_regular_upgrade
+
+       printf "Updating /boot partition\n"
+       tar xzf /misc/firmware/boot.tgz -C /tmp/boot
+       [ $? -eq 0 ] && printf "/boot partition updated successfully\n" || printf "/boot partition update failed\n"
+       sync
+
+       printf "Updating /root partition\n"
+       tar xzf /misc/firmware/rootfs.tgz -C /tmp/rootpart
+       [ $? -eq 0 ] && printf "/root partition updated successfully\n" || printf "/root partition update failed\n"
+       sync
+
+       # Saving configuration files over sysupgrade
+       platform_copy_config_uDPU
+
+       # Remove tmp mounts
+       tmp_parts=$(grep "${emmc_dev}" /proc/mounts | awk '{print $2}')
+       for part in ${tmp_parts}; do
+               umount $part
+               # Force umount is necessary
+               [ "$(grep "${part}" /proc/mounts)" ] && umount -l $part
+       done
+
+       # Sysupgrade complains about /tmp and /dev, so we can detach them here
+       umount -l /tmp
+       umount -l /dev
+}
+
+platform_copy_config_uDPU() {
+       # Config is saved on the /misc partition and copied on the rootfs after the reboot
+       if [ -f "$UPGRADE_BACKUP" ]; then
+               cp -f "$UPGRADE_BACKUP" "/misc/$BACKUP_FILE"
+               sync
+       fi
+}
diff --git a/target/linux/mvebu/cortexa72/base-files/etc/board.d/02_network b/target/linux/mvebu/cortexa72/base-files/etc/board.d/02_network
new file mode 100755 (executable)
index 0000000..080e32a
--- /dev/null
@@ -0,0 +1,30 @@
+#!/bin/sh
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+. /lib/functions/uci-defaults.sh
+
+board_config_update
+
+board=$(board_name)
+
+case "$board" in
+marvell,armada8040-mcbin)
+       ucidef_set_interfaces_lan_wan "eth0 eth1 eth3" "eth2"
+       ;;
+marvell,armada8040-db)
+       ucidef_set_interfaces_lan_wan "eth0 eth2 eth3" "eth1"
+       ;;
+marvell,armada7040-db)
+       ucidef_set_interfaces_lan_wan "eth0 eth2" "eth1"
+       ;;
+*)
+       ucidef_set_interface_lan "eth0"
+       ;;
+esac
+
+board_config_flush
+
+exit 0
diff --git a/target/linux/mvebu/cortexa72/base-files/lib/upgrade/platform.sh b/target/linux/mvebu/cortexa72/base-files/lib/upgrade/platform.sh
new file mode 100755 (executable)
index 0000000..2428de0
--- /dev/null
@@ -0,0 +1,37 @@
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+RAMFS_COPY_BIN='fw_printenv fw_setenv'
+RAMFS_COPY_DATA='/etc/fw_env.config /var/lock/fw_printenv.lock'
+REQUIRE_IMAGE_METADATA=1
+
+platform_check_image() {
+       case "$(board_name)" in
+       marvell,armada8040-mcbin)
+               platform_check_image_sdcard "$1"
+               ;;
+       *)
+               return 0
+               ;;
+       esac
+}
+
+platform_do_upgrade() {
+       case "$(board_name)" in
+       marvell,armada8040-mcbin)
+               platform_do_upgrade_sdcard "$1"
+               ;;
+       *)
+               default_do_upgrade "$1"
+               ;;
+       esac
+}
+platform_copy_config() {
+       case "$(board_name)" in
+       marvell,armada8040-mcbin)
+               platform_copy_config_sdcard
+               ;;
+       esac
+}
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/board.d/01_leds b/target/linux/mvebu/cortexa9/base-files/etc/board.d/01_leds
new file mode 100755 (executable)
index 0000000..a7762f0
--- /dev/null
@@ -0,0 +1,40 @@
+#!/bin/sh
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+. /lib/functions/uci-defaults.sh
+
+board_config_update
+
+board=$(board_name)
+boardname="${board##*,}"
+
+case "$board" in
+linksys,caiman|\
+linksys,cobra|\
+linksys,rango|\
+linksys,shelby)
+       ucidef_set_led_netdev "wan" "WAN" "pca963x:$boardname:white:wan" "eth1"
+       ucidef_set_led_usbport "usb1" "USB 1" "pca963x:$boardname:white:usb2" "usb1-port1"
+       ucidef_set_led_usbport "usb2" "USB 2" "pca963x:$boardname:white:usb3_1" "usb2-port1" "usb3-port1"
+       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:$boardname:white:usb3_2" "usb3-port1"
+       ;;
+linksys,mamba)
+       ucidef_set_led_netdev "wan" "WAN" "mamba:white:wan" "eth1"
+       ucidef_set_led_usbport "usb1" "USB 1" "mamba:white:usb2" "usb1-port1"
+       ucidef_set_led_usbport "usb2" "USB 2" "mamba:white:usb3_1" "usb2-port1" "usb3-port1"
+       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "mamba:white:usb3_2" "usb3-port2"
+       ;;
+linksys,venom)
+       ucidef_set_led_netdev "wan" "WAN" "pca963x:venom:blue:wan" "eth1"
+       ucidef_set_led_usbport "usb1" "USB 1" "pca963x:venom:blue:usb2" "usb1-port1"
+       ucidef_set_led_usbport "usb2" "USB 2" "pca963x:venom:blue:usb3_1" "usb2-port1" "usb3-port1"
+       ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:venom:blue:usb3_2" "usb3-port1"
+       ;;
+esac
+
+board_config_flush
+
+exit 0
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/board.d/02_network b/target/linux/mvebu/cortexa9/base-files/etc/board.d/02_network
new file mode 100755 (executable)
index 0000000..b10e141
--- /dev/null
@@ -0,0 +1,58 @@
+#!/bin/sh
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+. /lib/functions/uci-defaults.sh
+
+board_config_update
+
+board=$(board_name)
+
+case "$board" in
+cznic,turris-omnia)
+       ucidef_set_interface_lan "lan0 lan1 lan2 lan3 lan4"
+       ucidef_set_interface_wan "eth2"
+       ;;
+linksys,caiman|\
+linksys,cobra|\
+linksys,mamba|\
+linksys,rango|\
+linksys,shelby|\
+linksys,venom)
+       ucidef_set_interfaces_lan_wan "eth0.1" "eth1.2"
+       ucidef_add_switch "switch0" \
+               "0:lan:4" "1:lan:3" "2:lan:2" "3:lan:1" "5@eth0" "4:wan" "6@eth1"
+       ;;
+marvell,a385-db-ap)
+       ucidef_set_interfaces_lan_wan "eth0 eth1" "eth2"
+       ;;
+marvell,axp-gp)
+       ucidef_set_interface_lan "eth0 eth1 eth2 eth3"
+       ;;
+solidrun,clearfog-a1|\
+solidrun,clearfog-pro-a1)
+       # eth0 is standalone ethernet
+       # eth1 is switch
+       # eth2 is SFP
+       ucidef_set_interfaces_lan_wan "eth1" "eth0 eth2"
+
+       # switch port 5 is connected to eth1
+       ucidef_add_switch "switch0" \
+               "0:lan:5" "1:lan:4" "2:lan:3" "3:lan:2" "4:lan:1" "5u@eth1" "6:lan:6"
+       ;;
+solidrun,clearfog-base-a1)
+       # eth0 is standalone ethernet
+       # eth1 is standalone ethernet
+       # eth2 is SFP
+       ucidef_set_interfaces_lan_wan "eth1" "eth0 eth2"
+       ;;
+*)
+       ucidef_set_interface_lan "eth0"
+       ;;
+esac
+
+board_config_flush
+
+exit 0
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/init.d/bootcount b/target/linux/mvebu/cortexa9/base-files/etc/init.d/bootcount
new file mode 100755 (executable)
index 0000000..dd2266b
--- /dev/null
@@ -0,0 +1,16 @@
+#!/bin/sh /etc/rc.common
+
+START=99
+
+boot() {
+       case $(board_name) in
+       linksys,caiman |\
+       linksys,cobra |\
+       linksys,mamba |\
+       linksys,rango |\
+       linksys,shelby |\
+       linksys,venom)
+               mtd resetbc s_env || true
+               ;;
+       esac
+}
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/03_wireless b/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/03_wireless
new file mode 100644 (file)
index 0000000..3c345ff
--- /dev/null
@@ -0,0 +1,56 @@
+#!/bin/sh
+#
+# Copyright (C) 2015 OpenWrt.org
+#
+
+[ ! -e /etc/config/wireless ] && exit 0
+
+. /lib/functions.sh
+. /lib/functions/system.sh
+
+board=$(board_name)
+
+case "$board" in
+linksys,caiman|linksys,cobra|linksys,mamba|linksys,shelby|linksys,venom)
+       SKU=$(strings /dev/mtd3|sed -ne 's/^cert_region=//p')
+       WIFIMAC2G=$(macaddr_add $(cat /sys/class/net/eth0/address) +1)
+       WIFIMAC5G=$(macaddr_add $WIFIMAC2G +1)
+       case "$SKU" in
+               AP)
+                       REGD=CN
+               ;;
+               AU)
+                       REGD=AU
+               ;;
+               CA)
+                       REGD=CA
+               ;;
+               EU)
+                       REGD=DE
+               ;;
+               US)
+                       REGD=US
+               ;;
+       esac
+
+       case "$board" in
+               linksys,mamba)
+                       WIFIMAC0=$WIFIMAC2G
+                       WIFIMAC1=$WIFIMAC5G
+               ;;
+               *)
+                       WIFIMAC0=$WIFIMAC5G
+                       WIFIMAC1=$WIFIMAC2G
+               ;;
+       esac
+
+       uci get wireless.radio0.country || uci set wireless.radio0.country=$REGD
+       uci get wireless.@wifi-iface[0].macaddr || uci set wireless.@wifi-iface[0].macaddr=$WIFIMAC0
+       uci get wireless.radio1.country || uci set wireless.radio1.country=$REGD
+       uci get wireless.@wifi-iface[1].macaddr || uci set wireless.@wifi-iface[1].macaddr=$WIFIMAC1
+       ;;
+esac
+
+uci commit wireless
+
+exit 0
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/04_mambafan b/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/04_mambafan
new file mode 100644 (file)
index 0000000..ec25aed
--- /dev/null
@@ -0,0 +1,23 @@
+#!/bin/sh
+#
+# Copyright (C) 2017 LEDE-Project.org
+#
+
+. /lib/functions.sh
+
+board=$(board_name)
+
+case "$board" in
+linksys,mamba)
+       # Set fan script execution in crontab
+       grep -s -q fan_ctrl.sh /etc/crontabs/root && exit 0
+
+       echo "# mamba fan script runs every 5 minutes" >> /etc/crontabs/root
+       echo "*/5 * * * * /sbin/fan_ctrl.sh" >> /etc/crontabs/root
+
+       # Execute one time after initial flash (instead of waiting 5 min for cron)
+       /sbin/fan_ctrl.sh
+       ;;
+esac
+
+exit 0
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac b/target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac
new file mode 100644 (file)
index 0000000..fd41836
--- /dev/null
@@ -0,0 +1,46 @@
+#
+# Copyright (C) 2014-2015 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+preinit_set_mac_address() {
+       local mac
+
+       . /lib/functions.sh
+
+       case $(board_name) in
+       linksys,caiman|linksys,cobra|linksys,rango|linksys,shelby|linksys,venom)
+               # rename interfaces back to the way they were with 4.4
+               case "$(readlink /sys/class/net/eth0)" in
+                       *f1070000*)
+                               ip link set eth0 name tmp0
+                               ip link set eth1 name eth0
+                               ip link set tmp0 name eth1
+                       ;;
+               esac
+
+               mac=$(mtd_get_mac_ascii devinfo hw_mac_addr)
+               mac_wan=$(macaddr_setbit_la "$mac")
+               ip link set dev eth0 address $mac 2>/dev/null
+               ip link set dev eth1 address $mac_wan 2>/dev/null
+               ;;
+       linksys,mamba)
+               mac=$(mtd_get_mac_ascii devinfo hw_mac_addr)
+               ip link set dev eth0 address $mac 2>/dev/null
+               ip link set dev eth1 address $mac 2>/dev/null
+               ;;
+       marvell,a385-db-ap|solidrun,clearfog*a1)
+               # rename interfaces back to the way they were with 4.4
+               case "$(readlink /sys/class/net/eth0)" in
+                       *f1070000*)
+                               ip link set eth0 name tmp0
+                               ip link set eth1 name eth0
+                               ip link set eth2 name eth1
+                               ip link set tmp0 name eth2
+                       ;;
+               esac
+               ;;
+       esac
+}
+
+boot_hook_add preinit_main preinit_set_mac_address
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg b/target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg
new file mode 100644 (file)
index 0000000..83448e5
--- /dev/null
@@ -0,0 +1,37 @@
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+preinit_mount_syscfg() {
+       . /lib/functions.sh
+       . /lib/upgrade/common.sh
+
+       case $(board_name) in
+       linksys,caiman|linksys,cobra|linksys,mamba|linksys,rango|linksys,shelby|linksys,venom)
+               needs_recovery=0
+               syscfg_part=$(grep syscfg /proc/mtd |cut -c4)
+               ubiattach -m $syscfg_part || needs_recovery=1
+               if [ $needs_recovery -eq 1 ]
+               then
+                       echo "ubifs syscfg partition is damaged, reformatting"
+                       ubidetach -m $syscfg_part
+                       ubiformat -y -O 2048 -q /dev/mtd$syscfg_part
+                       ubiattach -m $syscfg_part
+                       ubimkvol /dev/ubi1 -n 0 -N syscfg -t dynamic --maxavsize
+               fi
+               mkdir /tmp/syscfg
+               mount -t ubifs ubi1:syscfg /tmp/syscfg
+               [ -f "/tmp/syscfg/$BACKUP_FILE" ] && {
+               echo "- config restore -"
+               cd /
+               mv "/tmp/syscfg/$BACKUP_FILE" /tmp
+               tar xzf "/tmp/$BACKUP_FILE"
+               rm -f "/tmp/$BACKUP_FILE"
+               sync
+               }
+               ;;
+       esac
+}
+
+boot_hook_add preinit_main preinit_mount_syscfg
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
new file mode 100644 (file)
index 0000000..6ccfdd0
--- /dev/null
@@ -0,0 +1,98 @@
+#
+# Copyright (C) 2014-2015 OpenWrt.org
+#
+
+linksys_get_target_firmware() {
+
+       local cur_boot_part mtd_ubi0
+
+       cur_boot_part=$(/usr/sbin/fw_printenv -n boot_part)
+       if [ -z "${cur_boot_part}" ] ; then
+               mtd_ubi0=$(cat /sys/devices/virtual/ubi/ubi0/mtd_num)
+               case $(egrep ^mtd${mtd_ubi0}: /proc/mtd | cut -d '"' -f 2) in
+               kernel1|rootfs1)
+                       cur_boot_part=1
+                       ;;
+               kernel2|rootfs2)
+                       cur_boot_part=2
+                       ;;
+               esac
+               >&2 printf "Current boot_part='%s' selected from ubi0/mtd_num='%s'" \
+                       "${cur_boot_part}" "${mtd_ubi0}"
+       fi
+
+       case $cur_boot_part in
+       1)
+               fw_setenv -s - <<-EOF
+                       boot_part 2
+                       bootcmd "run altnandboot"
+               EOF
+               printf "kernel2"
+               return
+               ;;
+       2)
+               fw_setenv -s - <<-EOF
+                       boot_part 1
+                       bootcmd "run nandboot"
+               EOF
+               printf "kernel1"
+               return
+               ;;
+       *)
+               return
+               ;;
+       esac
+}
+
+linksys_get_root_magic() {
+       (get_image "$@" | dd skip=786432 bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
+}
+
+platform_do_upgrade_linksys() {
+       local magic_long="$(get_magic_long "$1")"
+
+       mkdir -p /var/lock
+       local part_label="$(linksys_get_target_firmware)"
+       touch /var/lock/fw_printenv.lock
+
+       if [ ! -n "$part_label" ]
+       then
+               echo "cannot find target partition"
+               exit 1
+       fi
+
+       local target_mtd=$(find_mtd_part $part_label)
+
+       [ "$magic_long" = "73797375" ] && {
+               CI_KERNPART="$part_label"
+               if [ "$part_label" = "kernel1" ]
+               then
+                       CI_UBIPART="rootfs1"
+               else
+                       CI_UBIPART="rootfs2"
+               fi
+
+               nand_upgrade_tar "$1"
+       }
+       [ "$magic_long" = "27051956" -o "$magic_long" = "0000a0e1" ] && {
+               # check firmwares' rootfs types
+               local target_mtd=$(find_mtd_part $part_label)
+               local oldroot="$(linksys_get_root_magic $target_mtd)"
+               local newroot="$(linksys_get_root_magic "$1")"
+
+               if [ "$newroot" = "55424923" -a "$oldroot" = "55424923" ]
+               # we're upgrading from a firmware with UBI to one with UBI
+               then
+                       # erase everything to be safe
+                       mtd erase $part_label
+                       get_image "$1" | mtd -n write - $part_label
+               else
+                       get_image "$1" | mtd write - $part_label
+               fi
+       }
+}
+
+platform_copy_config_linksys() {
+       cp -f "$UPGRADE_BACKUP" "/tmp/syscfg/$BACKUP_FILE"
+       sync
+}
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh
new file mode 100755 (executable)
index 0000000..8baed96
--- /dev/null
@@ -0,0 +1,59 @@
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+RAMFS_COPY_BIN='fw_printenv fw_setenv'
+RAMFS_COPY_DATA='/etc/fw_env.config /var/lock/fw_printenv.lock'
+REQUIRE_IMAGE_METADATA=1
+
+platform_check_image() {
+       case "$(board_name)" in
+       cznic,turris-omnia|\
+       solidrun,clearfog-base-a1|\
+       solidrun,clearfog-pro-a1)
+               platform_check_image_sdcard "$1"
+               ;;
+       *)
+               return 0
+               ;;
+       esac
+}
+
+platform_do_upgrade() {
+       case "$(board_name)" in
+       cznic,turris-omnia|\
+       solidrun,clearfog-base-a1|\
+       solidrun,clearfog-pro-a1)
+               platform_do_upgrade_sdcard "$1"
+               ;;
+       linksys,caiman|\
+       linksys,cobra|\
+       linksys,mamba|\
+       linksys,rango|\
+       linksys,shelby|\
+       linksys,venom)
+               platform_do_upgrade_linksys "$1"
+               ;;
+       *)
+               default_do_upgrade "$1"
+               ;;
+       esac
+}
+platform_copy_config() {
+       case "$(board_name)" in
+       cznic,turris-omnia|\
+       solidrun,clearfog-base-a1|\
+       solidrun,clearfog-pro-a1)
+               platform_copy_config_sdcard
+               ;;
+       linksys,caiman|\
+       linksys,cobra|\
+       linksys,mamba|\
+       linksys,rango|\
+       linksys,shelby|\
+       linksys,venom)
+               platform_copy_config_linksys
+               ;;
+       esac
+}